ROM_form.vhd

Ken Chapman (Xilinx Ltd) July 2003

This is the VHDL template file for the KCPSM3 assembler.
It is used to configure a Spartan-3, Virtex-II or Virtex-IIPRO block RAM to act as 
a single port program ROM.

This VHDL file is not valid as input directly into a synthesis or simulation tool.
The assembler will read this template and insert the data required to complete the 
definition of program ROM and write it out to a new '.vhd' file associated with the 
name of the original '.psm' file being assembled.

This template can be modified to define alternative memory definitions such as dual port.
However, you are responsible for ensuring the template is correct as the assembler does 
not perform any checking of the VHDL.

The assembler identifies all text enclosed by {} characters, and replaces these
character strings. All templates should include these {} character strings for 
the assembler to work correctly. 

****************************************************************************************
	
This template defines a block RAM configured in 1024 x 18-bit single port mode and 
conneceted to act as a single port ROM.

****************************************************************************************

The next line is used to determine where the template actually starts and must exist.
{begin template}
--
-- Definition of a single port ROM for KCPSM3 program defined by {name}.psm
--
-- Generated by KCPSM3 Assembler {timestamp}. 
--
-- Standard IEEE libraries
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
--
-- The Unisim Library is used to define Xilinx primitives. It is also used during
-- simulation. The source can be viewed at %XILINX%\vhdl\src\unisims\unisim_VCOMP.vhd
--  
library unisim;
use unisim.vcomponents.all;
--
--
entity {name} is
    Port (      address : in std_logic_vector(9 downto 0);
            instruction : out std_logic_vector(17 downto 0);
                    clk : in std_logic);
    end {name};
--
architecture low_level_definition of {name} is
--
-- Attributes to define ROM contents during implementation synthesis. 
-- The information is repeated in the generic map for functional simulation
--
attribute INIT_00 : string; 
attribute INIT_01 : string; 
attribute INIT_02 : string; 
attribute INIT_03 : string; 
attribute INIT_04 : string; 
attribute INIT_05 : string; 
attribute INIT_06 : string; 
attribute INIT_07 : string; 
attribute INIT_08 : string; 
attribute INIT_09 : string; 
attribute INIT_0A : string; 
attribute INIT_0B : string; 
attribute INIT_0C : string; 
attribute INIT_0D : string; 
attribute INIT_0E : string; 
attribute INIT_0F : string; 

--
-- Attributes to define ROM contents during implementation synthesis.
--
attribute INIT_00 of RAMB4_S4_inst_0  : label is "{INIT_00}";
attribute INIT_01 of RAMB4_S4_inst_0  : label is "{INIT_01}";
attribute INIT_02 of RAMB4_S4_inst_0  : label is "{INIT_02}";
attribute INIT_03 of RAMB4_S4_inst_0  : label is "{INIT_03}";
attribute INIT_04 of RAMB4_S4_inst_0  : label is "{INIT_04}";
attribute INIT_05 of RAMB4_S4_inst_0  : label is "{INIT_05}";
attribute INIT_06 of RAMB4_S4_inst_0  : label is "{INIT_06}";
attribute INIT_07 of RAMB4_S4_inst_0  : label is "{INIT_07}";
attribute INIT_08 of RAMB4_S4_inst_0  : label is "{INIT_08}";
attribute INIT_09 of RAMB4_S4_inst_0  : label is "{INIT_09}";
attribute INIT_0A of RAMB4_S4_inst_0  : label is "{INIT_0A}";
attribute INIT_0B of RAMB4_S4_inst_0  : label is "{INIT_0B}";
attribute INIT_0C of RAMB4_S4_inst_0  : label is "{INIT_0C}";
attribute INIT_0D of RAMB4_S4_inst_0  : label is "{INIT_0D}";
attribute INIT_0E of RAMB4_S4_inst_0  : label is "{INIT_0E}";
attribute INIT_0F of RAMB4_S4_inst_0  : label is "{INIT_0F}";

--
begin
--
  --Instantiate the Xilinx primitive for a block RAM
   RAMB4_S4_inst_0 : RAMB4_S4
   generic map (
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000"
      )      
   port map (
      DO    => instruction(3 downto 0),     -- 4-bit data output
      ADDR  => address, -- 10-bit address input
      CLK   => clk,   -- Clock input
      DI    => "0000",     -- 4-bit data input
      EN    => '1',     -- RAM enable input
      RST   => '0',   -- Synchronous reset input
      WE    => '0'      -- RAM write enable input
   );
--
end low_level_definition;
--
------------------------------------------------------------------------------------
--
-- END OF FILE {name}.vhd
--
------------------------------------------------------------------------------------


-- !!!! tohle nejak vohnou !!!!!!
   -- RAMB4_S4: Virtex/E, Spartan-II/IIE 1k x 4 Single-Port RAM
   -- Xilinx  HDL Language Template version 7.1i



   -- End of RAMB4_S4_inst instantiation
